Index: serefpolicy-contrib-20140730/rpm.fc
===================================================================
--- serefpolicy-contrib-20140730.orig/rpm.fc
+++ serefpolicy-contrib-20140730/rpm.fc
@@ -1,61 +1,74 @@
-/bin/rpm	--	gen_context(system_u:object_r:rpm_exec_t,s0)
 
-/etc/rc\.d/init\.d/bcfg2	--	gen_context(system_u:object_r:rpm_initrc_exec_t,s0)
-
-/sbin/yast2	--	gen_context(system_u:object_r:rpm_exec_t,s0)
+/bin/rpm 			--	gen_context(system_u:object_r:rpm_exec_t,s0)
 
+/usr/bin/anaconda-yum		--	gen_context(system_u:object_r:rpm_exec_t,s0)
 /usr/bin/debuginfo-install	--	gen_context(system_u:object_r:debuginfo_exec_t,s0)
-/usr/bin/fedora-rmdevelrpms	--	gen_context(system_u:object_r:rpm_exec_t,s0)
-/usr/bin/online_update	--	gen_context(system_u:object_r:rpm_exec_t,s0)
-/usr/bin/rpmdev-rmdevelrpms	--	gen_context(system_u:object_r:rpm_exec_t,s0)
-/usr/bin/rpm	--	gen_context(system_u:object_r:rpm_exec_t,s0)
-/usr/bin/smart	--	gen_context(system_u:object_r:rpm_exec_t,s0)
-/usr/bin/yum	--	gen_context(system_u:object_r:rpm_exec_t,s0)
-/usr/bin/zif	--	gen_context(system_u:object_r:rpm_exec_t,s0)
+/usr/bin/dnf			--	gen_context(system_u:object_r:rpm_exec_t,s0)
+/usr/bin/rpm 			--	gen_context(system_u:object_r:rpm_exec_t,s0)
+/usr/bin/smart 			--	gen_context(system_u:object_r:rpm_exec_t,s0)
+
+/bin/yum-builddep		--	gen_context(system_u:object_r:rpm_exec_t,s0)
+/usr/bin/yum 			--	gen_context(system_u:object_r:rpm_exec_t,s0)
+/usr/bin/yum-builddep	--	gen_context(system_u:object_r:rpm_exec_t,s0)
+/usr/bin/repoquery		--	gen_context(system_u:object_r:rpm_exec_t,s0)		
+/usr/bin/zif 			--	gen_context(system_u:object_r:rpm_exec_t,s0)
 
 /usr/libexec/packagekitd	--	gen_context(system_u:object_r:rpm_exec_t,s0)
 /usr/libexec/yumDBUSBackend.py	--	gen_context(system_u:object_r:rpm_exec_t,s0)
+/usr/libexec/pegasus/pycmpiLMI_Software-cimprovagt  --  gen_context(system_u:object_r:rpm_exec_t,s0)
 
-/usr/sbin/bcfg2	--	gen_context(system_u:object_r:rpm_exec_t,s0)
-/usr/sbin/pirut	--	gen_context(system_u:object_r:rpm_exec_t,s0)
-/usr/sbin/pup	--	gen_context(system_u:object_r:rpm_exec_t,s0)
-/usr/sbin/rhn_check	--	gen_context(system_u:object_r:rpm_exec_t,s0)
-/usr/sbin/up2date	--	gen_context(system_u:object_r:rpm_exec_t,s0)
-/usr/sbin/yum-complete-transaction	--	gen_context(system_u:object_r:rpm_exec_t,s0)
-/usr/sbin/system-install-packages	--	gen_context(system_u:object_r:rpm_exec_t,s0)
-/usr/sbin/yum-updatesd	--	gen_context(system_u:object_r:rpm_exec_t,s0)
-/usr/sbin/packagekitd	--	gen_context(system_u:object_r:rpm_exec_t,s0)
-
-ifdef(`distro_redhat',`
-/usr/bin/apt-get	--	gen_context(system_u:object_r:rpm_exec_t,s0)
-/usr/bin/apt-shell	--	gen_context(system_u:object_r:rpm_exec_t,s0)
-/usr/bin/aptitude	--	gen_context(system_u:object_r:rpm_exec_t,s0)
-/usr/sbin/synaptic	--	gen_context(system_u:object_r:rpm_exec_t,s0)
-/var/cache/PackageKit(/.*)?	gen_context(system_u:object_r:rpm_var_cache_t,s0)
-/var/lib/PackageKit(/.*)?	gen_context(system_u:object_r:rpm_var_lib_t,s0)
-')
-
-/usr/share/yumex/yumex-yum-backend	--	gen_context(system_u:object_r:rpm_exec_t,s0)
-/usr/share/yumex/yum_childtask\.py	--	gen_context(system_u:object_r:rpm_exec_t,s0)
-
-/var/cache/bcfg2(/.*)?	gen_context(system_u:object_r:rpm_var_cache_t,s0)
-/var/cache/yum(/.*)?	gen_context(system_u:object_r:rpm_var_cache_t,s0)
+/usr/sbin/yum-complete-transaction --	gen_context(system_u:object_r:rpm_exec_t,s0)
 
-/var/lib/alternatives(/.*)?	gen_context(system_u:object_r:rpm_var_lib_t,s0)
-/var/lib/rpm(/.*)?	gen_context(system_u:object_r:rpm_var_lib_t,s0)
-/var/lib/YaST2(/.*)?	gen_context(system_u:object_r:rpm_var_lib_t,s0)
-/var/lib/yum(/.*)?	gen_context(system_u:object_r:rpm_var_lib_t,s0)
+/usr/sbin/system-install-packages --	gen_context(system_u:object_r:rpm_exec_t,s0)
+/usr/sbin/yum-updatesd		--	gen_context(system_u:object_r:rpm_exec_t,s0)
+/usr/sbin/yum-cron		--	gen_context(system_u:object_r:rpm_exec_t,s0)
+/usr/sbin/packagekitd		--	gen_context(system_u:object_r:rpm_exec_t,s0)
 
-/var/lock/bcfg2\.run	--	gen_context(system_u:object_r:rpm_lock_t,s0)
+/usr/share/yumex/yumex-yum-backend --	gen_context(system_u:object_r:rpm_exec_t,s0)
+/usr/share/yumex/yum_childtask\.py --	gen_context(system_u:object_r:rpm_exec_t,s0)
 
-/var/log/YaST2(/.*)?	gen_context(system_u:object_r:rpm_log_t,s0)
-/var/log/yum\.log.*	--	gen_context(system_u:object_r:rpm_log_t,s0)
-
-/var/spool/up2date(/.*)?	gen_context(system_u:object_r:rpm_var_cache_t,s0)
+ifdef(`distro_redhat', `
+/usr/sbin/bcfg2				--	gen_context(system_u:object_r:rpm_exec_t,s0)
+/usr/bin/package-cleanup	--	gen_context(system_u:object_r:rpm_exec_t,s0)
+/usr/bin/fedora-rmdevelrpms	--	gen_context(system_u:object_r:rpm_exec_t,s0)
+/usr/bin/rpmdev-rmdevelrpms	--	gen_context(system_u:object_r:rpm_exec_t,s0)
+/usr/sbin/pirut			--	gen_context(system_u:object_r:rpm_exec_t,s0)
+/usr/sbin/pup			--	gen_context(system_u:object_r:rpm_exec_t,s0)
+/usr/sbin/rhn_check		--	gen_context(system_u:object_r:rpm_exec_t,s0)
+/usr/sbin/rhnreg_ks		--  gen_context(system_u:object_r:rpm_exec_t,s0)
+/usr/sbin/up2date		--	gen_context(system_u:object_r:rpm_exec_t,s0)
+/usr/sbin/synaptic		--	gen_context(system_u:object_r:rpm_exec_t,s0)
+/usr/bin/apt-get		--	gen_context(system_u:object_r:rpm_exec_t,s0)
+/usr/bin/apt-shell		--	gen_context(system_u:object_r:rpm_exec_t,s0)
+')
 
-/var/run/yum.*	--	gen_context(system_u:object_r:rpm_var_run_t,s0)
-/var/run/PackageKit(/.*)?	gen_context(system_u:object_r:rpm_var_run_t,s0)
+/var/cache/PackageKit(/.*)?		gen_context(system_u:object_r:rpm_var_cache_t,s0)
+/var/cache/yum(/.*)?			gen_context(system_u:object_r:rpm_var_cache_t,s0)
+/var/cache/dnf(/.*)?			gen_context(system_u:object_r:rpm_var_cache_t,s0)
+
+/var/lib/alternatives(/.*)?		gen_context(system_u:object_r:rpm_var_lib_t,s0)
+/var/lib/PackageKit(/.*)?		gen_context(system_u:object_r:rpm_var_lib_t,s0)
+/var/lib/rpm(/.*)?			gen_context(system_u:object_r:rpm_var_lib_t,s0)
+/var/lib/yum(/.*)?			gen_context(system_u:object_r:rpm_var_lib_t,s0)
+/var/lib/dnf(/.*)?			gen_context(system_u:object_r:rpm_var_lib_t,s0)
+
+/var/log/yum\.log.*		--	gen_context(system_u:object_r:rpm_log_t,s0)
+/var/log/up2date.*		--	gen_context(system_u:object_r:rpm_log_t,s0)
+
+
+/var/spool/up2date(/.*)?		gen_context(system_u:object_r:rpm_var_cache_t,s0)
+
+/var/run/yum.*			--	gen_context(system_u:object_r:rpm_var_run_t,s0)
+/var/run/PackageKit(/.*)?		gen_context(system_u:object_r:rpm_var_run_t,s0)
+
+# SuSE
+ifdef(`distro_suse', `
+/usr/bin/online_update		--	gen_context(system_u:object_r:rpm_exec_t,s0)
+/sbin/yast2			--	gen_context(system_u:object_r:rpm_exec_t,s0)
+/var/lib/YaST2(/.*)?			gen_context(system_u:object_r:rpm_var_lib_t,s0)
+/var/log/YaST2(/.*)?			gen_context(system_u:object_r:rpm_log_t,s0)
+')
 
 ifdef(`enable_mls',`
-/usr/sbin/cpio	--	gen_context(system_u:object_r:rpm_exec_t,s0)
+/sbin/cpio			--	gen_context(system_u:object_r:rpm_exec_t,s0)
 ')
Index: serefpolicy-contrib-20140730/rpm.if
===================================================================
--- serefpolicy-contrib-20140730.orig/rpm.if
+++ serefpolicy-contrib-20140730/rpm.if
@@ -1,8 +1,8 @@
-## <summary>Redhat package manager.</summary>
+## <summary>Policy for the RPM package manager.</summary>
 
 ########################################
 ## <summary>
-##	Execute rpm in the rpm domain.
+##	Execute rpm programs in the rpm domain.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -13,16 +13,18 @@
 interface(`rpm_domtrans',`
 	gen_require(`
 		type rpm_t, rpm_exec_t;
+		attribute rpm_transition_domain;
 	')
 
 	corecmd_search_bin($1)
 	domtrans_pattern($1, rpm_exec_t, rpm_t)
+	typeattribute $1 rpm_transition_domain;
+	rpm_debuginfo_domtrans($1)
 ')
 
 ########################################
 ## <summary>
-##	Execute debuginfo install
-##	in the rpm domain.
+##	Execute debuginfo_install programs in the rpm domain.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -41,7 +43,7 @@ interface(`rpm_debuginfo_domtrans',`
 
 ########################################
 ## <summary>
-##	Execute rpm scripts in the rpm script domain.
+##	Execute rpm_script programs in the rpm_script domain.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -54,18 +56,16 @@ interface(`rpm_domtrans_script',`
 		type rpm_script_t;
 	')
 
+	# transition to rpm script:
 	corecmd_shell_domtrans($1, rpm_script_t)
-
 	allow rpm_script_t $1:fd use;
-	allow rpm_script_t $1:fifo_file rw_fifo_file_perms;
+	allow rpm_script_t $1:fifo_file rw_file_perms;
 	allow rpm_script_t $1:process sigchld;
 ')
 
 ########################################
 ## <summary>
-##	Execute rpm in the rpm domain,
-##	and allow the specified roles the
-##	rpm domain.
+##	Execute RPM programs in the RPM domain.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -74,23 +74,28 @@ interface(`rpm_domtrans_script',`
 ## </param>
 ## <param name="role">
 ##	<summary>
-##	Role allowed access.
+##	The role to allow the RPM domain.
 ##	</summary>
 ## </param>
 ## <rolecap/>
 #
 interface(`rpm_run',`
 	gen_require(`
-		attribute_role rpm_roles;
+		type rpm_t, rpm_script_t;
+		attribute_role rpm_script_roles;
 	')
 
 	rpm_domtrans($1)
-	roleattribute $2 rpm_roles;
+	roleattribute $2 rpm_script_roles;
+
+	domain_system_change_exemption($1)
+	role_transition $2 rpm_exec_t system_r;
+	allow $2 system_r;
 ')
 
 ########################################
 ## <summary>
-##	Execute the rpm in the caller domain.
+##	Execute the rpm client in the caller domain.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -109,7 +114,7 @@ interface(`rpm_exec',`
 
 ########################################
 ## <summary>
-##	Send null signals to rpm.
+##	Send a null signal to rpm.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -127,7 +132,7 @@ interface(`rpm_signull',`
 
 ########################################
 ## <summary>
-##	Inherit and use file descriptors from rpm.
+##	Inherit and use file descriptors from RPM.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -145,7 +150,7 @@ interface(`rpm_use_fds',`
 
 ########################################
 ## <summary>
-##	Read rpm unnamed pipes.
+##	Read from an unnamed RPM pipe.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -163,7 +168,7 @@ interface(`rpm_read_pipes',`
 
 ########################################
 ## <summary>
-##	Read and write rpm unnamed pipes.
+##	Read and write an unnamed RPM pipe.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -181,6 +186,60 @@ interface(`rpm_rw_pipes',`
 
 ########################################
 ## <summary>
+##	Read and write an unnamed RPM script pipe.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`rpm_rw_script_inherited_pipes',`
+	gen_require(`
+		type rpm_script_tmp_t;
+	')
+
+	allow $1 rpm_script_tmp_t:fifo_file rw_inherited_fifo_file_perms;
+')
+
+########################################
+## <summary>
+##	dontaudit read and write an leaked file descriptors
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain to not audit.
+##	</summary>
+## </param>
+#
+interface(`rpm_dontaudit_leaks',`
+	gen_require(`
+		type rpm_t, rpm_var_cache_t;
+		type rpm_script_t, rpm_var_run_t, rpm_tmp_t;
+		type rpm_tmpfs_t, rpm_script_tmp_t, rpm_var_lib_t;
+	')
+
+	dontaudit $1 rpm_t:fifo_file rw_inherited_fifo_file_perms;
+ 	dontaudit $1 rpm_t:tcp_socket { read write };
+	dontaudit $1 rpm_t:unix_dgram_socket { read write };
+	dontaudit $1 rpm_t:shm rw_shm_perms;
+
+	dontaudit $1 rpm_script_t:fd use;
+	dontaudit $1 rpm_script_t:fifo_file rw_inherited_fifo_file_perms;
+
+	dontaudit $1 rpm_var_run_t:file rw_inherited_file_perms;
+
+	dontaudit $1 rpm_tmp_t:file rw_inherited_file_perms;
+ 	dontaudit $1 rpm_tmpfs_t:dir rw_dir_perms;
+ 	dontaudit $1 rpm_tmpfs_t:file rw_inherited_file_perms;
+	dontaudit $1 rpm_script_tmp_t:file rw_inherited_file_perms;
+	dontaudit $1 rpm_var_lib_t:dir getattr;
+	dontaudit $1 rpm_var_lib_t:file rw_inherited_file_perms;
+	dontaudit $1 rpm_var_cache_t:file  rw_inherited_file_perms;
+')
+
+########################################
+## <summary>
 ##	Send and receive messages from
 ##	rpm over dbus.
 ## </summary>
@@ -224,7 +283,7 @@ interface(`rpm_dontaudit_dbus_chat',`
 ########################################
 ## <summary>
 ##	Send and receive messages from
-##	rpm script over dbus.
+##	rpm_script over dbus.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -244,7 +303,7 @@ interface(`rpm_script_dbus_chat',`
 
 ########################################
 ## <summary>
-##	Search rpm log directories.
+##	Search RPM log directory.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -263,7 +322,8 @@ interface(`rpm_search_log',`
 
 #####################################
 ## <summary>
-##	Append rpm log files.
+##	Allow the specified domain to append
+##	to rpm log files.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -276,14 +336,30 @@ interface(`rpm_append_log',`
 		type rpm_log_t;
 	')
 
-	logging_search_logs($1)
-	append_files_pattern($1, rpm_log_t, rpm_log_t)
+	allow $1 rpm_log_t:file append_inherited_file_perms;
+')
+
+########################################
+## <summary>
+##	Create, read, write, and delete the RPM log.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`rpm_read_log',`
+	gen_require(`
+		type rpm_log_t;
+	')
+
+    read_files_pattern($1, rpm_log_t, rpm_log_t)
 ')
 
 ########################################
 ## <summary>
-##	Create, read, write, and delete
-##	rpm log files.
+##	Create, read, write, and delete the RPM log.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -302,7 +378,25 @@ interface(`rpm_manage_log',`
 
 ########################################
 ## <summary>
-##	Inherit and use rpm script file descriptors.
+##	Create rpm logs with an correct label.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`rpm_named_filetrans_log_files',`
+	gen_require(`
+		type rpm_log_t;
+	')
+    logging_log_named_filetrans($1, rpm_log_t, file, "yum.log")
+    logging_log_named_filetrans($1, rpm_log_t, file, "up2date")
+')
+
+########################################
+## <summary>
+##	Inherit and use file descriptors from RPM scripts.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -320,8 +414,8 @@ interface(`rpm_use_script_fds',`
 
 ########################################
 ## <summary>
-##	Create, read, write, and delete
-##	rpm script temporary files.
+##	Create, read, write, and delete RPM
+##	script temporary files.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -335,12 +429,15 @@ interface(`rpm_manage_script_tmp_files',
 	')
 
 	files_search_tmp($1)
+	manage_dirs_pattern($1, rpm_script_tmp_t, rpm_script_tmp_t)
 	manage_files_pattern($1, rpm_script_tmp_t, rpm_script_tmp_t)
+	manage_lnk_files_pattern($1, rpm_script_tmp_t, rpm_script_tmp_t)
 ')
 
 #####################################
 ## <summary>
-##	Append rpm temporary files.
+##	Allow the specified domain to append
+##	to rpm tmp files.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -353,14 +450,13 @@ interface(`rpm_append_tmp_files',`
 		type rpm_tmp_t;
 	')
 
-	files_search_tmp($1)
-	append_files_pattern($1, rpm_tmp_t, rpm_tmp_t)
+	allow $1 rpm_tmp_t:file append_inherited_file_perms;
 ')
 
 ########################################
 ## <summary>
-##	Create, read, write, and delete
-##	rpm temporary files.
+##	Create, read, write, and delete RPM
+##	 temporary files.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -374,12 +470,14 @@ interface(`rpm_manage_tmp_files',`
 	')
 
 	files_search_tmp($1)
+	manage_dirs_pattern($1, rpm_tmp_t, rpm_tmp_t)
 	manage_files_pattern($1, rpm_tmp_t, rpm_tmp_t)
+	manage_lnk_files_pattern($1, rpm_tmp_t, rpm_tmp_t)
 ')
 
 ########################################
 ## <summary>
-##	Read rpm script temporary files.
+##	Read RPM script temporary files.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -399,7 +497,7 @@ interface(`rpm_read_script_tmp_files',`
 
 ########################################
 ## <summary>
-##	Read rpm cache content.
+##	Read the RPM cache.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -420,8 +518,7 @@ interface(`rpm_read_cache',`
 
 ########################################
 ## <summary>
-##	Create, read, write, and delete
-##	rpm cache content.
+##	Create, read, write, and delete the RPM package database.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -442,7 +539,7 @@ interface(`rpm_manage_cache',`
 
 ########################################
 ## <summary>
-##	Read rpm lib content.
+##	Read the RPM package database.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -459,11 +556,12 @@ interface(`rpm_read_db',`
 	allow $1 rpm_var_lib_t:dir list_dir_perms;
 	read_files_pattern($1, rpm_var_lib_t, rpm_var_lib_t)
 	read_lnk_files_pattern($1, rpm_var_lib_t, rpm_var_lib_t)
+	rpm_read_cache($1)
 ')
 
 ########################################
 ## <summary>
-##	Delete rpm lib files.
+##	Delete the RPM package database.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -482,8 +580,7 @@ interface(`rpm_delete_db',`
 
 ########################################
 ## <summary>
-##	Create, read, write, and delete
-##	rpm lib files.
+##	Create, read, write, and delete the RPM package database.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -503,8 +600,28 @@ interface(`rpm_manage_db',`
 
 ########################################
 ## <summary>
+##	Do not audit attempts to create, read,the RPM package database.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain to not audit.
+##	</summary>
+## </param>
+#
+interface(`rpm_dontaudit_read_db',`
+	gen_require(`
+		type rpm_var_lib_t;
+	')
+
+	dontaudit $1 rpm_var_lib_t:dir list_dir_perms;
+	dontaudit $1 rpm_var_lib_t:file read_file_perms;
+	dontaudit $1 rpm_var_lib_t:lnk_file read_lnk_file_perms;
+')
+
+########################################
+## <summary>
 ##	Do not audit attempts to create, read,
-##	write, and delete rpm lib content.
+##	write, and delete the RPM package database.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -517,7 +634,7 @@ interface(`rpm_dontaudit_manage_db',`
 		type rpm_var_lib_t;
 	')
 
-	dontaudit $1 rpm_var_lib_t:dir rw_dir_perms;
+	dontaudit $1 rpm_var_lib_t:dir manage_dir_perms;
 	dontaudit $1 rpm_var_lib_t:file manage_file_perms;
 	dontaudit $1 rpm_var_lib_t:lnk_file manage_lnk_file_perms;
 ')
@@ -543,8 +660,7 @@ interface(`rpm_read_pid_files',`
 
 #####################################
 ## <summary>
-##	Create, read, write, and delete
-##	rpm pid files.
+##	Create, read, write, and delete rpm pid files.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -563,8 +679,7 @@ interface(`rpm_manage_pid_files',`
 
 ######################################
 ## <summary>
-##	Create files in pid directories
-##	with the rpm pid file type.
+##	Create files in /var/run with the rpm pid file type.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -573,43 +688,54 @@ interface(`rpm_manage_pid_files',`
 ## </param>
 #
 interface(`rpm_pid_filetrans',`
-	refpolicywarn(`$0($*) has been deprecated, rpm_pid_filetrans_rpm_pid() instead.')
-	rpm_pid_filetrans_rpm_pid($1, file)
+	gen_require(`
+		type rpm_var_run_t;
+	')
+
+	files_pid_filetrans($1, rpm_var_run_t, file)
 ')
 
 ########################################
 ## <summary>
-##	Create specified objects in pid directories
-##	with the rpm pid file type.
+##	Send a null signal to rpm.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
 ##	Domain allowed access.
 ##	</summary>
 ## </param>
-## <param name="object_class">
-##	<summary>
-##	Class of the object being created.
-##	</summary>
-## </param>
-## <param name="name" optional="true">
+#
+interface(`rpm_inherited_fifo',`
+	gen_require(`
+		attribute rpm_transition_domain;
+	')
+
+	allow $1 rpm_transition_domain:fifo_file rw_inherited_fifo_file_perms;
+')
+
+
+########################################
+## <summary>
+##	Make rpm_exec_t an entry point for
+##	the specified domain.
+## </summary>
+## <param name="domain">
 ##	<summary>
-##	The name of the object being created.
+##	Domain allowed access.
 ##	</summary>
 ## </param>
-#
-interface(`rpm_pid_filetrans_rpm_pid',`
+# 
+interface(`rpm_entry_type',`
 	gen_require(`
-		type rpm_var_run_t;
+		type rpm_exec_t;
 	')
 
-	files_pid_filetrans($1, rpm_var_run_t, $3, $4)
+	domain_entry_file($1, rpm_exec_t)
 ')
 
 ########################################
 ## <summary>
-##	All of the rules required to
-##	administrate an rpm environment.
+##	Allow application to transition to rpm_script domain.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -617,22 +743,56 @@ interface(`rpm_pid_filetrans_rpm_pid',`
 ##	</summary>
 ## </param>
 ## <param name="role">
-##	<summary>
-##	Role allowed access.
-##	</summary>
+##  <summary>
+##  Role allowed access.
+##  </summary>
 ## </param>
-## <rolecap/>
 #
-interface(`rpm_admin',`
+interface(`rpm_transition_script',`
 	gen_require(`
-		type rpm_t, rpm_script_t, rpm_initrc_exec_t;
-		type rpm_var_cache_t, rpm_var_lib_t, rpm_lock_t;
-		type rpm_log_t, rpm_tmpfs_t, rpm_tmp_t;
-		type rpm_script_tmp_t, rpm_script_tmpfs_t, rpm_file_t;
+		type rpm_script_t;
+		attribute rpm_transition_domain;
+		attribute_role rpm_script_roles;
 	')
 
-	allow $1 { rpm_t rpm_script_t }:process { ptrace signal_perms };
-	ps_process_pattern($1, { rpm_t rpm_script_t })
+	typeattribute $1 rpm_transition_domain;
+	allow $1 rpm_script_t:process transition;
+	roleattribute $2 rpm_script_roles;
+
+	allow $1 rpm_script_t:fd use;
+	allow rpm_script_t $1:fd use;
+	allow rpm_script_t $1:fifo_file rw_fifo_file_perms;
+	allow rpm_script_t $1:process sigchld;
+')
+
+#######################################
+## <summary>
+##  All of the rules required to
+##  administrate an rpm environment.
+## </summary>
+## <param name="domain">
+##  <summary>
+##  Domain allowed access.
+##  </summary>
+## </param>
+## <param name="role">
+##  <summary>
+##  Role allowed access.
+##  </summary>
+## </param>
+## <rolecap/>
+#
+interface(`rpm_admin',`
+    gen_require(`
+        type rpm_t, rpm_script_t, rpm_initrc_exec_t;
+        type rpm_var_cache_t, rpm_var_lib_t, rpm_lock_t;
+
+        type rpm_log_t, rpm_tmpfs_t, rpm_tmp_t;
+        type rpm_script_tmp_t, rpm_script_tmpfs_t, rpm_file_t;
+    ')
+
+    allow $1 { rpm_t rpm_script_t }:process { ptrace signal_perms };
+    ps_process_pattern($1, { rpm_t rpm_script_t })
 
 	init_labeled_script_domtrans($1, rpm_initrc_exec_t)
 	domain_system_change_exemption($1)
